(version 2)
(include "sci.sh")
(exports
    0 SQ5
)
(use "Print")
(use "DialogControls")
(use "SysWindow")
(use "Game")
(use "Obj")
(script 0)

(define STARTING_ROOM 100)

(local
    gEgo
    gGame
    gRoom
    global3		// Unused
    gQuitGame = FALSE
    gOldCast
    gRegions
    gTimers
    gSounds
    gInv
    gOldATPs
    gModNum				// In the SCI0 game this was called gRoomNumberExit. It's what gets set to move to the next room, which will then be gRoomNumber
    					// It's used everywhere in place of gRoomNumber here though.
    gPreviousRoomNumber
    gRoomNumber
    gDebugOnNextRoom
    gScore
    gMaxScore
    global17
    gNewSet
    gCursorNumber
    gCursor =     999
    gInvisibleCursor =     997
    gFont =     1
    gSmallFont =     4
    gPEvent
    gDialog
    gBigFont =     1
    gVersion
    gSaveDir
    gPicAngle
    gOldFeatures
    global34
    gPicNumber =     -1
    gCastMotionCue
    gWindow
    global39	// Unused	(foreground text?)
    global40	// Unused	(window background color?)
    gOldPort
    global42[21] // debug filename
    gGameControls
    gFeatureInit
    gDoVerbCode
    gApproachCode
    global67 =     1		// Has something to do with default Motion for ego (0: MoveTo, 1: PolyPath, 2: PolyPath...)
    gayIconBar
    gPEventX
    gPEventY
    gOldKH
    gOldMH
    gOldDH
    gPseudoMouse
    gTheDoits
    gEatTheMice =     60
    gUser
    global81				// Something to do with Sync
    gNewSync
    global83				// Something to do with audio narration
    gNewEventHandler
    gFont_2
    global86				// Something to do with time (ticks per frame?)
    gLastTicks
    gNarrator
    global90 =     $0001	// Seems to be a flag for talker: 0x1 (text) and 0x2 (audio)
    gTestMessager
    gPrintEventHandler
    gOldWH
    gTextReadSpeed =     2
    gAltPolyList
    gColorDepth
    gPolyphony
    gStopGroop
    global107
    gCurrentIcon
    gGUserCanControl
    gGUserCanInput
    gCheckedIcons
    gState
    gNewSpeakWindow
    gWindow2
    gDeathReason
    gMusic1
    gDongle = 1234				// This variable CAN'T MOVE
    gMusic2
    gCurrentTalkerNumber
    gGEgoMoveSpeed
    gColorWindowForeground
    gColorWindowBackground
    gLowlightColor
    gDefaultEgoView =     0		// The default view resource for the ego
    gRegister
    gFlags[14]					// Start of bit set. Room for 14x16 = 224 flags.
    gEdgeDistance = 10			// Margin around screen to make it easier to walk the ego to the edge
)


(class public SQ5 of Game
    (properties
        script 0
        printLang 1
        _detailLevel 3
        panelObj 0
        panelSelector 0
        handsOffCode 0
        handsOnCode 0
    )

	/*
		Modify this to set up any initial state the game needs. Among the things set here are:
		
		- The maximum score.
		- Text colors and fonts used in messages.
		- The action icons.
		- The default game cursor.
		
	*/
    (method (init)
        (var temp0[7], temp7)
        (super:init())
        //= gEgo ego
        //(User:
        //    alterEgo(gEgo)
        //    canControl(0)
        //    canInput(0)
        //)
        = global90 $0001
        = global34 1
        = gPolyphony DoSound(sndGET_POLYPHONY)
        = gMaxScore 5000
        = gFont 1
        = gGEgoMoveSpeed 6
        = gEatTheMice 30
        = gTextReadSpeed 2
        = gColorDepth Graph(grGET_COLOURS)
        //(send gEgo:setLoop(gStopGroop))
        TextFonts(1605 1605 1605 1605 1605 0)
        TextColors(0 15 26 31 34 52 63)
        = gVersion "x.yyy.zzz"
        = temp7 FileIO(fiOPEN "version" fOPENFAIL)
        FileIO(fiREAD_STRING gVersion 11 temp7)
        FileIO(fiCLOSE temp7)
		= gColorWindowForeground 0
		= gLowlightColor 23
		= gColorWindowBackground 23
        = gWindow mainWindow
        = gWindow2 mainWindow
        (send gWindow:
            color(gColorWindowForeground)
            back(gColorWindowBackground)
        )
        (send gGame:
            setCursor(gCursorNumber TRUE 304 172)
            detailLevel(3)
        )
        = gCursor 999
        = gInvisibleCursor 996
    )

    (method (doit param1)
        (if (GameIsRestarting())
            = gColorDepth Graph(grGET_COLOURS)
        )
        (super:doit(rest param1))
    )


    (method (play)
        = gGame self
        = gSaveDir GetSaveDir()
        
        (if (not GameIsRestarting())
            GetCWD(gSaveDir)
        )
        (self:
            setCursor(gInvisibleCursor 1)
            init()
        )
        (self:newRoom(STARTING_ROOM))
        
        (while (not gQuitGame)
            (self:doit())
        )
    )

    (method (setCursor cursorNumber param2 param3 param4)
        (var theGCursorNumber)
        = theGCursorNumber gCursorNumber
        (if (paramTotal)
            (if (IsObject(cursorNumber))
                = gCursorNumber cursorNumber
                (send gCursorNumber:init())
            )(else
                = gCursorNumber cursorNumber
                SetCursor(gCursorNumber 0 0)
            )
        )
        (if ((> paramTotal 1) and not param2)
            SetCursor(996 0 0)
        )
        (if (> paramTotal 2)
            SetCursor(param3 param4)
        )
        return theGCursorNumber
    )
)

(instance mainWindow of SysWindow
    (properties)
)
